#include "d3dx8math.h"
#include "math_matrix.h"




D3DXMATRIX Angle2Matrix( const D3DXVECTOR3 &vect )
{
/*	D3DXMATRIX mat(1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1);
	float sx, sy, sz, cx, cy, cz;
//	angle = D3DXToRadian( vect.x );		sx = sinf(angle);	cx = cosf(angle);
//	angle = D3DXToRadian( vect.y );		sy = sinf(angle);	cy = cosf(angle);
//	angle = D3DXToRadian( vect.z );		sz = sinf(angle);	cz = cosf(angle);
	sx = sinf(vect.x);	cx = cosf(vect.x);
	sy = sinf(vect.y);	cy = cosf(vect.y);
	sz = sinf(vect.z);	cz = cosf(vect.z);
	// angle = vec.z * D3DX_PI / 180;
 
	mat._11 = cy*cz;			mat._21 = cy*sz;			mat._31 = -sy;
	mat._12 = sx*sy*cz-cx*sz;	mat._22 = sx*sy*sz+cx*cz;	mat._32 = sx*sy;
	mat._13 = cx*sy*cz+sx*sz;	mat._23 = cx*sy*sz-sx*cz;	mat._33 = cx*cy;
	return mat;
	*/
	D3DXMATRIX matrix(1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1);
	float		angle;
	float		sr, sp, sy, cr, cp, cy;
	
	// yaw
	angle = vect.z;// * (Q_PI*2 / 360);
	sy = sinf(angle);
	cy = cosf(angle);

	// pitch
	angle = vect.y;// * (Q_PI*2 / 360);
	sp = sinf(angle);
	cp = cosf(angle);

	// roll
	angle = vect.x;// * (Q_PI*2 / 360);
	sr = sinf(angle);
	cr = cosf(angle);

	// matrix = (Z * Y) * X
	matrix._11 = cp*cy;		matrix._12 = sr*sp*cy+cr*-sy;		matrix._13 = (cr*sp*cy+-sr*-sy);	matrix._14 = 0.0;
	matrix._21 = cp*sy;		matrix._22 = sr*sp*sy+cr*cy;		matrix._23 = (cr*sp*sy+-sr*cy);		matrix._24 = 0.0;
	matrix._31 = -sp;		matrix._32 = sr*cp;					matrix._33 = cr*cp;					matrix._34 = 0.0;
	return matrix;
}

D3DXMATRIX Angle2InvMatrix( const D3DXVECTOR3 &vect )
{
	/*
	D3DXMATRIX mat(1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1);

	float sx, sy, sz, cx, cy, cz;
//	angle = D3DXToRadian( vec.x ); 	sx = sinf(angle);	cx = cosf(angle);
//	angle = D3DXToRadian( vec.y );	sy = sinf(angle);	cy = cosf(angle);
//	angle = D3DXToRadian( vec.z );	sz = sinf(angle);	cz = cosf(angle);
	sx = sinf(vec.x);	cx = cosf(vec.x);
	sy = sinf(vec.y);	cy = cosf(vec.y);
	sz = sinf(vec.z);	cz = cosf(vec.z);
	// angle = vec.z * D3DX_PI / 180;
 
	mat._11 = cy*cz;			mat._12 = cy*sz;			mat._13 = -sy;
	mat._21 = sx*sy*cz-cx*sz;	mat._22 = sx*sy*sz+cx*cz;	mat._23 = sx*sy;
	mat._31 = cx*sy*cz+sx*sz;	mat._32 = cx*sy*sz-sx*cz;	mat._33 = cx*cy;
//	D3DXMatrixTranspose( &mat, &mat );
	return mat;
	*/
	D3DXMATRIX matrix(1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1);
	float		angle;
	float		sr, sp, sy, cr, cp, cy;
	
	angle = vect.z;// * (Q_PI*2 / 360);
	sy = sinf(angle);
	cy = cosf(angle);
	angle = vect.y;// * (Q_PI*2 / 360);
	sp = sinf(angle);
	cp = cosf(angle);
	angle = vect.x;// * (Q_PI*2 / 360);
	sr = sinf(angle);
	cr = cosf(angle);

	// matrix = (Z * Y) * X
	matrix._11 = cp*cy;					matrix._12 = cp*sy;					matrix._13 = -sp;		matrix._14 = 0.0;
	matrix._21 = sr*sp*cy+cr*-sy;		matrix._22 = sr*sp*sy+cr*cy;		matrix._23 = sr*cp;		matrix._24 = 0.0;
	matrix._31 = (cr*sp*cy+-sr*-sy);	matrix._32 = (cr*sp*sy+-sr*cy);		matrix._33 = cr*cp;		matrix._34 = 0.0;
	return matrix;
}

D3DXMATRIX Vector2Matrix( const D3DXVECTOR3 &vect )
{
	return D3DXMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0, vect.x, vect.y, vect.z, 1);
//	return D3DXMATRIX(1,0,0,vect.x, 0,1,0,vect.y, 0,0,1,vect.z, 0,0,0,1);
}

D3DXMATRIX Vector2InvMatrix( const D3DXVECTOR3 &vect )
{
	return D3DXMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0, -vect.x,-vect.y,-vect.z,1);
	//return D3DXMATRIX(1,0,0,-vect.x, 0,1,0,-vect.y, 0,0,1,-vect.z, 0,0,0,1);
}


D3DXMATRIX EulerToQuatMtr(D3DXVECTOR3 const &rad) 
{ 
	float cx, cy, cz, sx, sy, sz, cycz, sysz; 
	D3DXVECTOR4 quat( 0, 0, 0, 1 );
	float wx, wy, wz, xx, yy, yz, xy, xz, zz, x2, y2, z2; 
	
	cx = cosf(rad.x/2); cy = cosf(rad.y/2); cz = cosf(rad.z/2); 
	sx = sinf(rad.x/2); sy = sinf(rad.y/2); sz = sinf(rad.z/2); 

	cycz = cy * cz; 
	sysz = sy * sz; 
	
	// quat = q1*q2*q3
	quat.w = cx * cycz + sx * sysz; 
	quat.x = sx * cycz - cx * sysz; 
	quat.y = cx * sy * cz + sx * cy * sz; 
	quat.z = cx * cy * sz - sx * sy * cz; 

	x2 = quat.x + quat.x; y2 = quat.y + quat.y; z2 = quat.z + quat.z; 
	xx = quat.x * x2;    xy = quat.x * y2;    xz = quat.x * z2; 
	yy = quat.y * y2;    yz = quat.y * z2;    zz = quat.z * z2; 
	wx = quat.w * x2;    wy = quat.w * y2;    wz = quat.w * z2; 

	// make matrix out of quaternion; 
	return D3DXMATRIX(1.0f - (yy + zz), xy - wz, xz + wy, 0.0f, 
					 xy + wz, 1.0f - (xx + zz), yz - wx, 0.0f,
					 xz - wy, yz + wx, 1.0f - (xx + yy), 0.0f,
					 0, 0, 0, 1);
} 

D3DXVECTOR3 VectorTransform( const D3DXVECTOR3 & vect, const D3DXMATRIX mat )
{
	D3DXVECTOR3 ret;
	ret.x = D3DXVec3Dot( &vect, &D3DXVECTOR3(mat._11, mat._12, mat._13) ) + mat._14;
	ret.y = D3DXVec3Dot( &vect, &D3DXVECTOR3(mat._21, mat._22, mat._23) ) + mat._24;
	ret.z = D3DXVec3Dot( &vect, &D3DXVECTOR3(mat._31, mat._32, mat._33) ) + mat._34;
	return ret;
}


D3DXMATRIX getTransposeMatrix( const D3DXMATRIX& mat )
{
	D3DXMATRIX ret;
	ret._11 = mat._11;	ret._12 = mat._21; ret._13 = mat._31; ret._14 = mat._41;
	ret._21 = mat._12;	ret._22 = mat._22; ret._23 = mat._32; ret._24 = mat._42;
	ret._31 = mat._13;	ret._32 = mat._23; ret._33 = mat._33; ret._34 = mat._43;
	ret._41 = mat._14;	ret._42 = mat._24; ret._43 = mat._34; ret._44 = mat._44;

	return ret;
}

D3DXMATRIX MatrixMulti( const D3DXMATRIX& mat1, const D3DXMATRIX& mat2 )
{
	D3DXMATRIX ret(1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1);
	ret._11 =	mat1._11 * mat2._11		+	mat1._12 * mat2._21		+	
				mat1._13 * mat2._31		+	mat1._14 * mat2._41;
	ret._12 =	mat1._11 * mat2._12		+	mat1._12 * mat2._22		+	
				mat1._13 * mat2._32		+	mat1._14 * mat2._42;
	ret._13 =	mat1._11 * mat2._13		+	mat1._12 * mat2._23		+	
				mat1._13 * mat2._33		+	mat1._14 * mat2._43;
	ret._14 =	mat1._11 * mat2._14		+	mat1._12 * mat2._24		+	
				mat1._13 * mat2._34		+	mat1._14 * mat2._44;

	ret._21 =	mat1._21 * mat2._11		+	mat1._22 * mat2._21		+	
				mat1._23 * mat2._31		+	mat1._24 * mat2._41;
	ret._22 =	mat1._21 * mat2._12		+	mat1._22 * mat2._22		+	
				mat1._23 * mat2._32		+	mat1._24 * mat2._42;
	ret._23 =	mat1._21 * mat2._13		+	mat1._22 * mat2._23		+	
				mat1._23 * mat2._33		+	mat1._24 * mat2._43;
	ret._24 =	mat1._21 * mat2._14		+	mat1._22 * mat2._24		+	
				mat1._23 * mat2._34		+	mat1._24 * mat2._44;

	ret._31 =	mat1._31 * mat2._11		+	mat1._32 * mat2._21		+	
				mat1._33 * mat2._31		+	mat1._34 * mat2._41;
	ret._32 =	mat1._31 * mat2._12		+	mat1._32 * mat2._22		+	
				mat1._33 * mat2._32		+	mat1._34 * mat2._42;
	ret._33 =	mat1._31 * mat2._13		+	mat1._32 * mat2._23		+	
				mat1._33 * mat2._33		+	mat1._34 * mat2._43;
	ret._34 =	mat1._31 * mat2._14		+	mat1._32 * mat2._24		+	
				mat1._33 * mat2._34		+	mat1._34 * mat2._44;

	ret._41 =	mat1._41 * mat2._11		+	mat1._42 * mat2._21		+	
				mat1._43 * mat2._31		+	mat1._44 * mat2._41;
	ret._42 =	mat1._41 * mat2._12		+	mat1._42 * mat2._22		+	
				mat1._43 * mat2._32		+	mat1._44 * mat2._42;
	ret._43 =	mat1._41 * mat2._13		+	mat1._42 * mat2._23		+	
				mat1._43 * mat2._33		+	mat1._44 * mat2._43;
	ret._44 =	mat1._41 * mat2._14		+	mat1._42 * mat2._24		+	
				mat1._43 * mat2._34		+	mat1._44 * mat2._44;

	return ret;
}