#include "d3dx8math.h"
#include "Vertex.h"


//- ؽ ǥ  -------------------------------------------------------------

CTexCoord::CTexCoord()
{
	tu = 0.0f;
	tv = 0.0f;
}

CTexCoord::~CTexCoord(){
}

CTexCoord::CTexCoord( float u, float v )
{
	tu = u;
	tv = v;
}

CTexCoord CTexCoord::operator = ( const CTexCoord &rhv )
{
	tu = rhv.tu;
	tv = rhv.tv;
	return *this;
}

CTexCoord CTexCoord::operator * ( const float &rhv ) const
{
	CTexCoord Temp;
	Temp.tu = tu * rhv;
	Temp.tv = tv * rhv;
	return Temp;
}
//--------------------------------------------------------------------------------







//////////////////////////////////////////////////////////////////////////////////
CVertex3::CVertex3()
{
	m_vPos	  = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );
	m_vNor	  = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );
}

CVertex3::~CVertex3() {
}

CVertex3::CVertex3( D3DXVECTOR3 &vPos, D3DXVECTOR3 &vNor, CTexCoord &cTex )
{
	m_vPos		= vPos;
	m_vNor		= vNor;
	m_oTex		= cTex;
}

CVertex3 CVertex3::operator = ( const CVertex3 &rhv )
{
	m_vPos		= rhv.m_vPos;
	m_vNor		= rhv.m_vNor;
	m_oTex		= rhv.m_oTex;

	return *this;
}
//////////////////////////////////////////////////////////////////////////////////




//////////////////////////////////////////////////////////////////////////////////
CVertex3_2::CVertex3_2() 
{
	m_vPos	  = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );
	m_vNor	  = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );
}

CVertex3_2::~CVertex3_2() {
}

CVertex3_2::CVertex3_2( D3DXVECTOR3 &vPos, D3DXVECTOR3 &vNor, CTexCoord &cTex1, CTexCoord &cTex2 )
{
	m_vPos		= vPos;
	m_vNor		= vNor;
	m_oTex1		= cTex1;
	m_oTex2		= cTex2;
}

CVertex3_2 CVertex3_2::operator = ( const CVertex3_2 &rhv )
{
	m_vPos		= rhv.m_vPos;
	m_vNor		= rhv.m_vNor;
	m_oTex1		= rhv.m_oTex1;
	m_oTex2		= rhv.m_oTex2;

	return *this;
}
//////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////
CLVertex3::CLVertex3() 
{
	m_vPos	  = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );
	m_dwColor = D3DCOLOR_XRGB( 255, 255, 255 );
}

CLVertex3::~CLVertex3() {
}

CLVertex3::CLVertex3( D3DXVECTOR3 &vPos, DWORD dwColor, CTexCoord &cTex )
{
	m_vPos		= vPos;
	m_dwColor	= dwColor;
	m_oTex		= cTex;
}

CLVertex3 CLVertex3::operator = ( const CLVertex3 &rhv )
{
	m_vPos		= rhv.m_vPos;
	m_dwColor	= rhv.m_dwColor;
	m_oTex		= rhv.m_oTex;

	return *this;
}
//////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////
CLVertex3_2::CLVertex3_2() 
{
	m_vPos	  = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );
	m_dwColor = D3DCOLOR_XRGB( 255, 255, 255 );
}

CLVertex3_2::~CLVertex3_2() {
}

CLVertex3_2::CLVertex3_2( D3DXVECTOR3 &vPos, DWORD dwColor, CTexCoord &cTex1, CTexCoord &cTex2 )
{
	m_vPos		= vPos;
	m_dwColor	= dwColor;
	m_oTex1		= cTex1;
	m_oTex2		= cTex2;
}

CLVertex3_2 CLVertex3_2::operator = ( const CLVertex3_2 &rhv )
{
	m_vPos		= rhv.m_vPos;
	m_dwColor	= rhv.m_dwColor;
	m_oTex1		= rhv.m_oTex1;
	m_oTex2		= rhv.m_oTex2;

	return *this;
}
//////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////
CTLVertex4::CTLVertex4() 
{
	m_vPos	  = D3DXVECTOR4( 0.0f, 0.0f, 0.0f, 1.0f );
	m_dwColor = D3DCOLOR_XRGB( 255, 255, 255 );
}

CTLVertex4::~CTLVertex4() {
}

CTLVertex4::CTLVertex4( D3DXVECTOR4 &vPos, DWORD dwColor, CTexCoord &cTex )
{
	m_vPos		= vPos;
	m_dwColor	= dwColor;
	m_oTex		= cTex;
}

CTLVertex4 CTLVertex4::operator = ( const CTLVertex4 &rhv )
{
	m_vPos		= rhv.m_vPos;
	m_dwColor	= rhv.m_dwColor;
	m_oTex		= rhv.m_oTex;

	return *this;
}
//////////////////////////////////////////////////////////////////////////////////