#ifndef _VERTEX_H
#define _VERTEX_H


//- ؽ ǥ  -------------------------------------------------------------

class CTexCoord{
public:
	float tu, tv;

	CTexCoord();
	~CTexCoord();
	CTexCoord( float u, float v );

	CTexCoord operator = ( const CTexCoord &rhv );
	CTexCoord operator * ( const float &rhv ) const;
};

//--------------------------------------------------------------------------------




//////////////////////////////////////////////////////////////////////////////////
#define D3DFVF_VERTEX3 ( D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1 )

class CVertex3 {
public:
	D3DXVECTOR3		m_vPos;			// Position
	D3DXVECTOR3		m_vNor;		    // Normal Vector
	CTexCoord		m_oTex;			// Texture Coordinate

	CVertex3();
	~CVertex3();
	CVertex3( D3DXVECTOR3 &vPos, D3DXVECTOR3 &vNor, CTexCoord &cTex );

	CVertex3 operator = ( const CVertex3 &rhv );
};
//////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////
#define D3DFVF_VERTEX3_2 ( D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX2 )

class CVertex3_2 {
public:
	D3DXVECTOR3		m_vPos;			// Position
	D3DXVECTOR3		m_vNor;		    // Normal Vector
	CTexCoord		m_oTex1;		// Texture Coordinate
	CTexCoord		m_oTex2;		// Texture Coordinate

	CVertex3_2();
	~CVertex3_2();
	CVertex3_2( D3DXVECTOR3 &vPos, D3DXVECTOR3 &vNor, CTexCoord &cTex1, CTexCoord &cTex2 );

	CVertex3_2 operator = ( const CVertex3_2 &rhv );
};
//////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////
#define D3DFVF_LVERTEX3 ( D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX1 )

class CLVertex3 {
public:
	D3DXVECTOR3		m_vPos;			// Position
	DWORD			m_dwColor;		// Color( calculated with Light )
	CTexCoord		m_oTex;			// Texture Coordinate

	CLVertex3();
	~CLVertex3();
	CLVertex3( D3DXVECTOR3 &vPos, DWORD dwColor, CTexCoord &cTex );

	CLVertex3 operator = ( const CLVertex3 &rhv );
};
//////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////
#define D3DFVF_LVERTEX3_2 ( D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX2 )

class CLVertex3_2 {
public:
	D3DXVECTOR3		m_vPos;			// Position
	DWORD			m_dwColor;		// Color( calculated with Light )
	CTexCoord		m_oTex1;		// Texture Coordinate
	CTexCoord		m_oTex2;		// Texture Coordinate

	CLVertex3_2();
	~CLVertex3_2();
	CLVertex3_2( D3DXVECTOR3 &vPos, DWORD dwColor, CTexCoord &cTex1, CTexCoord &cTex2 );

	CLVertex3_2 operator = ( const CLVertex3_2 &rhv );
};
//////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////
#define D3DFVF_TLVERTEX4 ( D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_TEX1 )

class CTLVertex4 {
public:
	D3DXVECTOR4		m_vPos;			// Position
	DWORD			m_dwColor;		// Color( calculated with Light )
	CTexCoord		m_oTex;			// Texture Coordinate

	CTLVertex4();
	~CTLVertex4();
	CTLVertex4( D3DXVECTOR4 &vPos, DWORD dwColor, CTexCoord &cTex );

	CTLVertex4 operator = ( const CTLVertex4 &rhv );
};
//////////////////////////////////////////////////////////////////////////////////


#endif